fl

{
LED driver (PCA9632)
      
PropForth 5.5
2015/04/21 12:50:38

PCA9632DP1(8pin)     Propeller
     Vdd  ------------ 3.3V
     SDA  ------------ SDA
     SCL  ------------ SCL
     GND  ------------ GND
     
     LED0 -- -LED+ -- 510ohm -- 3.3V
     LED1 -- -LED+ -- 510ohm -- 3.3V
     LED2 -- -LED+ -- 510ohm -- 3.3V
     LED3 -- -LED+ -- 510ohm -- 3.3V
}

\ =========================================================================== 
\ Constants 
\ =========================================================================== 
\ Slave addres h62 for PCA9632DP1 
hC4 wconstant PCA9632DP1
\ Software Reset 3
6 wconstant PCA9624_rst
\ All LED Call Address h70
hE0 wconstant PCA9624_call
\ Software Reset call
6 wconstant SWRST

\ register
0 wconstant mode1
1 wconstant mode2
2 wconstant PWM0
3 wconstant PWM1
4 wconstant PWM2
5 wconstant PWM3
6 wconstant GRPPWM
7 wconstant GRPFREQ
8 wconstant LEDOUT0
9 wconstant SUBADR1
hA wconstant SUBADR2
hB wconstant SUBADR3
hC wconstant ALLCALLADR

\ Auto Increment Code
0 wconstant no_inc
h80 wconstant all_inc          \ (register:0 - h11)
hA0 wconstant bright_inc       \ (register:2 - h11)
hC0 wconstant group_inc        \ (register:hA - hB)
hE0 wconstant brt_grp_inc      \ (register:2 - hB)
 
\ =========================================================================== 
\ Main 
\ =========================================================================== 

\ Software Reset
\ After send hA5 and h5A following SWRST, PCA9624 is resetting.
\ ( -- )
: SoftReset
\ Start I2C 
_eestart
\ Write SWRST, then receive Acknowledge-bit(ACK:Lo  NACK:Hi) 
SWRST _eewrite                      
hA5 _eewrite or
h5A _eewrite or
\ Stop I2C
_eestop
err? 
;

\ allocate string
\ ( -- )
: s, parsenw dup C@ 1+ bounds dup rot2 do C@++ c, loop drop ;

wvariable string -2 allot 
s, MODE1 s, MODE2 
s, PWM0 s, PWM1 s, PWM2 s, PWM3 
s, GRPPWM s, GRPFREQ
s, LEDOUT0 
s, SUBADR1 s, SUBADR2 s, SUBADR3
s, ALLCALLADR

\ Display allocated string above
\ ( n1 n2 -- )  n1:string index  n2:string's top address
: dispStr 
swap dup 0 <> 
if  
     0 do
          dup C@ + 1+
     loop     
else
     drop     
then 
.cstr 
;

\ TAB
\ ( -- )
: tab 9 emit ;
: 2tab tab tab ;

\ Set auto increment
\ ( -- )
: AutoIncr h80 or ;

\ Display all registers from mode1 to ALLCALLADR
\ ( -- )
: rd_allreg
hex
d13 0 do
     mode1 AutoIncr i + PCA9632DP1 i2c_rd err?
     i string dispStr ." :" 
     i 7 < if 2tab else tab then
     ." h" . cr   
loop
decimal
cr
;

\ Display all registers from ALLCALLADR to mode1
\ ( -- )
: rd_allreg_rev
hex
d13 mode1 AutoIncr PCA9632DP1 i2c_rd_multi err?
d13 0 do
     d12 i - string dispStr ." :" 
     i 6 < if tab else 2tab then
     ." h" . cr   
loop
decimal
cr
;

\ Drive 8 LED elemets from pwm 0% to pwm 99.6%
\ ( -- )
: demo
\ Set Normal[b4]
1 mode1 PCA9632DP1 i2c_wr err?   
\ Set LED3,2,1,0:PWM 
\ LDRx=10
hAA LEDOUT0 PCA9632DP1 i2c_wr err?  
            
begin
     d256 0 do
          i i i i 
          4 PWM0 AutoIncr PCA9632DP1 i2c_wr_multi err? 
          d10 delms
     loop                    
     fkey? swap drop         
until                     
SoftReset                        
;
